SystemOrganization addCategory: #ComposableLayouts!

ROTest subclass: #ROCenteredCircleLayoutTest
	instanceVariableNames: 'view elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ComposableLayouts'!

!ROCenteredCircleLayoutTest methodsFor: 'test layout' stamp: 'MarcelaRomero 10/25/2012 12:58'!
testDefaultCenter

	self assert: (ROCircleLayout new center = (0 @0))! !

!ROCenteredCircleLayoutTest methodsFor: 'test layout' stamp: 'MarcelaRomero 10/25/2012 12:57'!
testLayout

	| result |
	ROCircleTreeGridLayout new
		centeredOn: 100 @100;
		centeredOn: elements.
	
	! !

!ROCenteredCircleLayoutTest methodsFor: 'test layout' stamp: 'MarcelaRomero 10/25/2012 12:59'!
testSettingACenter
	| aLayout |
	aLayout := ROCircleLayout new.
	aLayout centeredOn: 20 @ 30.
	self assert: aLayout center = (20 @ 30)! !

ROAbstractGraphLayout subclass: #ROCircleTreeGridLayout
	instanceVariableNames: 'factor alreadyLayoutedNodes nodesByLayer center'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ComposableLayouts'!

!ROCircleTreeGridLayout methodsFor: 'hook' stamp: 'MarcelaRomero 10/25/2012 13:31'!
doExecute: elements
	|  rootNodes numElements |
	
	numElements := elements size.
	
	ROGridLayout on: (elements copyFrom: 1 to:  numElements/2).
	ROCircleLayout new
		centeredOn: elements first position;
		applyOn: (elements copyFrom: numElements/2 to: numElements).
	
	 
	
		
		

 ! !

!ROCircleTreeGridLayout methodsFor: 'initialize-release' stamp: 'MarcelaRomero 10/25/2012 13:31'!
initialize
	super initialize.
	factor := 200.
	! !

!ROCircleTreeGridLayout methodsFor: 'hook-private' stamp: 'MarcelaRomero 10/16/2012 11:17'!
layout: aNodeCollection atPoint: aPoint atLayer: aNumber
	| treeSize childrenPosition x y rad center angleTemp angle |
	 aNodeCollection isEmpty ifTrue: [^0].
	x := aPoint x.
	y := aPoint y.
	rad := aNodeCollection size * self scaleFactor.
	center :=  Point x: x y: y.
	angleTemp := 2 * Float pi / aNodeCollection size.
	angle := 0.
	alreadyLayoutedNodes addAll: aNodeCollection.
	"self atLayer: aNumber add: aNodeCollection."
	aNodeCollection do: [ :each |
		childrenPosition := center + (Point radius: rad theta: angle).
		angle := angle + angleTemp.
		translator translate: each to: childrenPosition ].
	
	^1.! !

!ROCircleTreeGridLayout methodsFor: 'accessing' stamp: 'MarcelaRomero 10/16/2012 10:24'!
scaleBy: aNumber
	"comment stating purpose of message"
	factor := aNumber.
	! !

!ROCircleTreeGridLayout methodsFor: 'accessing' stamp: 'MarcelaRomero 10/16/2012 10:26'!
scaleFactor
	"comment stating purpose of message"
	^factor
	! !
